

/**
 * 
 * Class with console utils.
 * 
 */
public class Console {

	/*
	 * Echo/print the object to output.
	 * 
	 */
	static public void echo(Object txt) {
		System.out.print(txt);
	}

	/*
	 * Echo/print a line to output.
	 * 
	 */
	static public void echoln(Object txt) {
		System.out.println(txt);
	}

	/*
	 * Read a line from input.
	 * 
	 * @return the line, including \n.
	 * 
	 */
	static public String inReadLine() {
		String line = "";

		while (line.indexOf("\n") < 0) {
			byte[] b = new byte[1];
			b[0] = inReadByte();
			line += new String(b);
		}

		return line;
	}

	/*
	 * Read a sinly byte.
	 * 
	 * @return the byte.
	 * 
	 */
	static public byte inReadByte() {
		byte[] b = new byte[1];
		try {
			System.in.read(b);
			return b[0];
		} catch (Exception e) {
			b[0] = 0;
			return b[0];
		}
	}

	/*
	 * Prompt for a line removing \n from returned string.
	 * 
	 * @param txt the message in the prompt line. @return returns the line read
	 * from input without \n.
	 * 
	 */
	static public String prompt(String txt) {
		String prompt = promptln(txt);

		if (prompt.indexOf("\r") >= 0)
			prompt = prompt.substring(0, prompt.indexOf("\r"));
		if (prompt.indexOf("\n") >= 0)
			prompt = prompt.substring(0, prompt.indexOf("\n"));

		return prompt;
	}

	/*
	 * Prompt for a line.
	 * 
	 * @param txt the message in the prompt line. @return returns the line read
	 * from input (with \n in the end).
	 * 
	 */
	static public String promptln(String txt) {
		if (txt.indexOf("...") < 0 && txt.indexOf(">") < txt.length() - 1)
			txt += "> ";

		echo(txt);
		return inReadLine();
	}

}
