import java.security.Key;
import java.security.KeyPair;


public class RSAandAES {
	
	public static void main(String[] args) {
		
		// Cria o par de chaves RSA  de 1024 bits:
		KeyPair keyRSA = RSA.generateKeyPair() ;
		
		// Cria a chave AES que ser usada nesta sesso:
		Key keyAES = AES.generateKey() ;
		
		// Texto a ser cifrado:
		String text = "abcdefghijklmnopqrstuvwxyz" ;
		byte[] data = text.getBytes() ;
		
		System.out.println("TEXT: <<"+ text +">>");
		
		// Random Initialization Vector (that will be used to initialize
		// CBC mode):
		byte[] iv = AES.createRandomIV() ;
		
		// Encrypt the data with AES:
		byte[] encryptedData = AES.encrypt(keyAES, data, iv) ;
		
		System.out.println("ENCRYPTED: <<"+ new String(encryptedData) +">>");
		
		// Convert the AES key to bytes, so is possible to send the key through Internet:
		byte[] keyAESData = AES.encodeKey(keyAES) ;
		
		// Encrypt AES key bytes with RSA public key:
		byte[] keyAESEncrypted = RSA.encrypt(keyRSA.getPublic() , keyAESData) ;
		
		///////////////////////////////////////////////////////////////////
		// Send encryptedData and keyAESEncrypted to destiny...
		/////////////////////////////////////////////////////////////////// 
		
		// Decrypt the AES key bytes using RSA:
		byte[] keyAESDecrypted = RSA.decrypt(keyRSA.getPrivate(), keyAESEncrypted) ;
		
		// Convert the AES key bytes to the AES Key instance:
		Key keyAESReceived = AES.decodeKey(keyAESDecrypted) ;
		
		// Decrypt the data using AES:
		byte[] decryptedData = AES.decrypt(keyAESReceived, encryptedData, iv) ;
		
		System.out.println("DECRYPTED: <<"+ new String(decryptedData) +">>");
		
	}

}
