import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;


public class SimpleP2PSocket {
	
	SimpleP2PClient client ;
	Socket socket ;
	
	DataOutputStream dout  ;
	DataInputStream din ;

	public SimpleP2PSocket(SimpleP2PClient client, Socket socket) throws IOException {
		this.client = client ;
		this.socket = socket;
		this.dout = new DataOutputStream( socket.getOutputStream() ) ;
		this.din = new DataInputStream( socket.getInputStream() ) ;
	}
	
	public SimpleP2PSocket(SimpleP2PClient client, String host , int port) throws IOException {
		this.client = client ;
		this.socket = new Socket(host , port) ;
		this.dout = new DataOutputStream( socket.getOutputStream() ) ;
		this.din = new DataInputStream( socket.getInputStream() ) ;
	}
	
	public void writeMsg(SimpleP2PMsg msg) throws IOException {
		byte[] blk = msg.getSerial() ;
		dout.writeInt(blk.length) ;
		dout.write(blk) ;
		dout.flush() ;
	}
	
	public SimpleP2PMsg readMsg() throws IOException {
		int size = din.readInt() ;
		byte[] blk = new byte[size] ;
		
		din.read(blk) ;
		
		SimpleP2PMsg msg = new SimpleP2PMsg(client , this, blk) ;
		 
		return msg ;
	}

	public void close() {
		try {
			socket.close();
		} catch (Exception e) {}
	}

	public boolean isConnected() {
		return socket.isConnected() && !socket.isClosed() ;
	}

	
}
